#include <iostream>

using namespace std;

void funkcija(char matrica[1001][1001], int n, int m, int i, int j, int& brojac) {
	if(matrica[i][j] == 'S' and i >= 0 and j >= 0 and i < n and j < m) {
		matrica[i][j] = 'S';
		brojac++;
		funkcija(matrica, n, m, i + 1, j, brojac);
		funkcija(matrica, n, m, i - 1, j, brojac);
		funkcija(matrica, n, m, i, j-1, brojac);
		funkcija(matrica, n, m, i, j+1, brojac);
	}
}
void funkcijax(char matrica[1001][1001], int n, int m, int i, int j) {
	if(matrica[i] [j] == 'X' and i >= 0 and j >= 0 and i < n and j < m) {
		matrica[i][j] = 'X';
		funkcijax(matrica, n, m, i + 1, j);
		funkcijax(matrica, n, m, i - 1, j);
		funkcijax(matrica, n, m, i, j-1);
		funkcijax(matrica, n, m, i, j+1);
	}
}


int main() {
	int n, m, brojac = 0;
	
	cin >> n >> m;
	
	char matrica[1001][1001];
	
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			cin >> matrica[i] [j];
		}
	}
		
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			if(matrica[i][j]=='S') {
				funkcija(matrica, n, m, i, j, brojac);
			}if(matrica[i][j]=='X'){
                funkcijax(matrica, n, m, i, j);
                brojac--;
            }
		}
	}
	
	cout << brojac;
	
	return 0;
}